/*--------------------------------------------------------------------
 C-Button Status script.
 by Plague (Linus Brolin)
--------------------------------------------------------------------*/

#include <lib/std.mi>

Class GuiObject HintObject;

Global HintObject Play, Stop, Previous, Next, Pause, Open;
Global HintObject PlayStatus, StopStatus, PreviousStatus, NextStatus, PauseStatus, OpenStatus;
Global HintObject PlayStatus2, StopStatus2, PreviousStatus2, NextStatus2, PauseStatus2, OpenStatus2;

System.onScriptLoaded() {

  Group pgroup = getScriptGroup();

  // Get Various buttons
  Play = pgroup.findObject("Play");
  Pause = pgroup.findObject("Pause");
  Stop = pgroup.findObject("Stop");
  Next = pgroup.findObject("Next");
  Previous = pgroup.findObject("Previous");
  Open = pgroup.findObject("Eject");

  // Get Various Labels
  PlayStatus = pgroup.findObject("Label Play over-active");
  PauseStatus = pgroup.findObject("Label Pause over-active");
  StopStatus = pgroup.findObject("Label Stop over-active");
  NextStatus = pgroup.findObject("Label Next over-active");
  PreviousStatus = pgroup.findObject("Label Prev over-active");
  OpenStatus = pgroup.findObject("Label Open over");

  // Because of a bug, I have to do this..
  PlayStatus2 = pgroup.findObject("Play2");
  PauseStatus2 = pgroup.findObject("Pause2");
  StopStatus2 = pgroup.findObject("Stop2");
  NextStatus2 = pgroup.findObject("Next2");
  PreviousStatus2 = pgroup.findObject("Previous2");
  OpenStatus2 = pgroup.findObject("Eject2");

  if (getStatus() == 1) PlayStatus.setAlpha(255);
  if (getStatus() == -1) PauseStatus.setAlpha(255);
  if (getStatus() == 0) StopStatus.setAlpha(255);
}

HintObject.onLeftButtonDown(int x, int y) {
  if (HintObject == Play) PlayStatus2.setAlpha(0);
  else if (HintObject == Stop) StopStatus2.setAlpha(0);
  else if (HintObject == Pause) PauseStatus2.setAlpha(0);
  else if (HintObject == Next) NextStatus2.setAlpha(0);
  else if (HintObject == Previous) PreviousStatus2.setAlpha(0);
  else if (HintObject == Open) OpenStatus2.setAlpha(0);
}

HintObject.onRightButtonDown(int x, int y) {
  if (HintObject == Play) PlayStatus2.setAlpha(0);
  else if (HintObject == Stop) StopStatus2.setAlpha(0);
  else if (HintObject == Pause) PauseStatus2.setAlpha(0);
  else if (HintObject == Next) NextStatus2.setAlpha(0);
  else if (HintObject == Previous) PreviousStatus2.setAlpha(0);
  else if (HintObject == Open) OpenStatus2.setAlpha(0);
}

HintObject.onEnterArea() {
  if (HintObject == Play) { PlayStatus.setAlpha(255); PlayStatus2.setAlpha(255); }
  else if (HintObject == Stop) { StopStatus.setAlpha(255); StopStatus2.setAlpha(255); }
  else if (HintObject == Pause) { PauseStatus.setAlpha(255); PauseStatus2.setAlpha(255); }
  else if (HintObject == Next) { NextStatus.setAlpha(255); NextStatus2.setAlpha(255); }
  else if (HintObject == Previous) { PreviousStatus.setAlpha(255); PreviousStatus2.setAlpha(255); }
  else if (HintObject == Open) { OpenStatus.setAlpha(255); OpenStatus2.setAlpha(255); }
}

HintObject.onLeaveArea() {
  if (HintObject == Play) {
    if (getStatus() != 1) PlayStatus.setAlpha(0);
    PlayStatus2.setAlpha(0);
  }
  else if (HintObject == Stop) {
    if (getStatus() != 0) StopStatus.setAlpha(0);
    StopStatus2.setAlpha(0);
  }
  else if (HintObject == Pause) {
    if (getStatus() != -1) PauseStatus.setAlpha(0);
    PauseStatus2.setAlpha(0);
  }
  else if (HintObject == Next) { NextStatus.setAlpha(0); NextStatus2.setAlpha(0); }
  else if (HintObject == Previous) { PreviousStatus.setAlpha(0); PreviousStatus2.setAlpha(0); }
  else if (HintObject == Open) { OpenStatus.setAlpha(0); OpenStatus2.setAlpha(0); }
}

System.onPlay() {
  StopStatus.setAlpha(0);
  PauseStatus.setAlpha(0);
  PlayStatus.setAlpha(255);
}

System.onStop() {
  PlayStatus.setAlpha(0);
  PauseStatus.setAlpha(0);
  StopStatus.setAlpha(255);
}

System.onPause() {
  PlayStatus.setAlpha(0);
  StopStatus.setAlpha(0);
  PauseStatus.setAlpha(255);
}

System.onResume() {
  StopStatus.setAlpha(0);
  PauseStatus.setAlpha(0);
  PlayStatus.setAlpha(255);
}
