/*-----------------------------------------------------------------------------
  crossfadebyframe.m

  by Plague (Linus Brolin)
  based on seekbyframe.m, by FrisbeeMonkey
-----------------------------------------------------------------------------*/

#include <lib/std.mi>
#include <lib/config.mi>

Function setFadebarAnim(int posValue);
Function updateFadebar(int x, int y);

Global AnimatedLayer Fadebar;
Global Map fadeMap;
Global Text SongTicker;
Global Boolean FadebarChanging;
Global ConfigAttribute attr_crossfade_time;

System.onScriptLoaded() {
  group pgroup = getScriptGroup();
  Fadebar = pgroup.findObject("XFadeAnim");
  Songticker = pgroup.findObject("SongTicker");

  fadeMap = new Map;
  fadeMap.loadMap("player.map.crossfade");

  ConfigItem item;
  item = Config.getItem("Crossfader");
  if (item != NULL) attr_crossfade_time = item.getAttribute("Crossfade time");
  
  int frame = stringToInteger(attr_crossfade_time.getData());
  setFadebarAnim(frame);
}

System.onScriptUnloading() {
  delete fadeMap;
}

setFadebarAnim(int Value) {
  int f = (Value * (Fadebar.getLength()-1)) / 21;
  if (Value > 0) Fadebar.gotoFrame(f+1);
  if (Value == 21) Fadebar.gotoFrame(f);
  if (Value == 0) Fadebar.gotoFrame(0);
}

attr_crossfade_time.onDataChanged() {
  int frame = stringToInteger(attr_crossfade_time.getData());
  setFadebarAnim(frame);
}

Fadebar.onLeftButtonDown(int x, int y) {
  FadebarChanging = 1;
  updateFadebar(x, y);
}

Fadebar.onLeftButtonUp(int x, int y) {
  if (FadebarChanging) {
    FadebarChanging = 0;
    updateFadebar(x, y);
  }
  Songticker.setAlternateText("");
}

Fadebar.onMouseMove(int x, int y) {
  if (FadebarChanging) {
    updateFadebar(x, y);
  }
}

updateFadebar(int x, int y) {
  int newValue = fadeMap.getValue(x - Fadebar.getLeft() + 20, y - Fadebar.getTop() + 20);
  if (fadeMap.inRegion(x - Fadebar.getLeft() + 20, y - Fadebar.getTop() + 20)) {
    int p = (newValue * 21) / 255;
    if (p == 1) Songticker.setAlternateText("Fade Duration: " + integerToString(p) + " second");
    else Songticker.setAlternateText("Fade Duration: " + integerToString(p) + " seconds");
    setFadebarAnim(p);
    attr_crossfade_time.setData(IntegerToString(p));
  }
}
