//-----------------------------
// drawer script
// by Plague (Linus Brolin)
//-----------------------------

#include <lib/std.mi>
#include "attribs.m"

Function toggleDrawer();

Global Button toggleBtn, toggleBtn2;
Global Boolean DrawerOut, AnimateDrawer;
Global Group Draw;
Global GuiObject colorThemes;
Global Layout normal;

System.onScriptLoaded() {
  initAttribs();

  normal = getScriptGroup();
  Draw = normal.findObject("right drawer");
  toggleBtn = normal.findObject("drawer");
  toggleBtn2 = Draw.findObject("toggle drawer");
  colorThemes = Draw.findObject("colorthemes");

  DrawerOut = getPrivateInt("D-Reliction", "DrawerOut", 0);
  if (DrawerOut) {
    normal.beforeRedock();
    normal.setXmlParam("snapadjustright", "0");
    Draw.setXmlParam("x", "243");
    normal.redock();
    colorThemes.show();
    toggleBtn.setActivated(1);
  } else {
    normal.beforeRedock();
    normal.setXmlParam("snapadjustright", "187");
    Draw.setXmlParam("x", "53");
    normal.redock();
    colorThemes.hide();
    toggleBtn.setActivated(0);
  }

  AnimateDrawer = stringToInteger(myattr_animateDrawer.getData());
}

System.onScriptUnloading() {
  setPrivateInt("D-Reliction","DrawerOut", DrawerOut);
}

myattr_animateDrawer.onDataChanged() {
  AnimateDrawer = stringToInteger(myattr_animateDrawer.getData());
}

toggleBtn.OnLeftClick() {
  toggleDrawer();
}

toggleBtn2.OnLeftClick() {
  toggleDrawer();
}

Draw.onTargetReached() {
  if (DrawerOut) {
    colorThemes.show();
    normal.beforeRedock();
    normal.setXmlParam("snapadjustright", "0");
    normal.redock();
  } else {
    normal.beforeRedock();
    normal.setXmlParam("snapadjustright", "187");
    normal.redock();
  }
}

toggleDrawer() {
  if (DrawerOut) {
    DrawerOut = 0;
    colorThemes.hide();
    toggleBtn.setActivated(0);
    if (AnimateDrawer) {
      Draw.setTargetX(53);
      Draw.setTargetSpeed(1);
      Draw.gotoTarget();
    } else {
      normal.beforeRedock();
      normal.setXmlParam("snapadjustright", "187");
      Draw.setXmlParam("x", "53");
      normal.redock();
    }
  } else {
    DrawerOut = 1;
    toggleBtn.setActivated(1);
    if (AnimateDrawer) {
      Draw.setTargetX(243);
      Draw.setTargetSpeed(1);
      Draw.gotoTarget();
    } else {
      normal.beforeRedock();
      normal.setXmlParam("snapadjustright", "0");
      Draw.setXmlParam("x", "243");
      normal.redock();
      colorThemes.show();
    }
  }
}
