/*

  Copyright (c) 2003-2004 Linus Brolin.

    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.


  Linus Brolin
  linus.b@home.se

*/

/*-----------------------------------------------------------------------------
  eqbars-filler.m

  by Plague (Linus Brolin)
-----------------------------------------------------------------------------*/

#include <lib/std.mi>

Function fillBar(int number, int value);

Global Slider pre, eq1, eq2, eq3, eq4, eq5, eq6, eq7, eq8, eq9, eq10;
Global AnimatedLayer pre_filler, eq1_filler, eq2_filler, eq3_filler, eq4_filler, eq5_filler, eq6_filler, eq7_filler, eq8_filler, eq9_filler, eq10_filler;

System.onScriptLoaded() {
  Group eq = getScriptGroup();

  pre = eq.findObject("preamp");
  pre_filler = eq.findObject("eq-filler-preamp");
  eq1 = eq.findObject("eq1");
  eq1_filler = eq.findObject("eq-filler-1");
  eq2 = eq.findObject("eq2");
  eq2_filler = eq.findObject("eq-filler-2");
  eq3 = eq.findObject("eq3");
  eq3_filler = eq.findObject("eq-filler-3");
  eq4 = eq.findObject("eq4");
  eq4_filler = eq.findObject("eq-filler-4");
  eq5 = eq.findObject("eq5");
  eq5_filler = eq.findObject("eq-filler-5");
  eq6 = eq.findObject("eq6");
  eq6_filler = eq.findObject("eq-filler-6");
  eq7 = eq.findObject("eq7");
  eq7_filler = eq.findObject("eq-filler-7");
  eq8 = eq.findObject("eq8");
  eq8_filler = eq.findObject("eq-filler-8");
  eq9 = eq.findObject("eq9");
  eq9_filler = eq.findObject("eq-filler-9");
  eq10 = eq.findObject("eq10");
  eq10_filler = eq.findObject("eq-filler-10");

  fillBar(0, pre.getPosition());
  fillBar(1, eq1.getPosition());
  fillBar(2, eq2.getPosition());
  fillBar(3, eq3.getPosition());
  fillBar(4, eq4.getPosition());
  fillBar(5, eq5.getPosition());
  fillBar(6, eq6.getPosition());
  fillBar(7, eq7.getPosition());
  fillBar(8, eq8.getPosition());
  fillBar(9, eq9.getPosition());
  fillBar(10, eq10.getPosition());
}

System.onEqPreampChanged(int newvalue) { fillBar(0, newvalue); }
System.onEqBandChanged(int band, int newvalue) { fillBar(band + 1, newvalue); }

fillBar(int num, int value) {
  AnimatedLayer filler;

  if (num == 0) filler = pre_filler;
  if (num == 1) filler = eq1_filler;
  if (num == 2) filler = eq2_filler;
  if (num == 3) filler = eq3_filler;
  if (num == 4) filler = eq4_filler;
  if (num == 5) filler = eq5_filler;
  if (num == 6) filler = eq6_filler;
  if (num == 7) filler = eq7_filler;
  if (num == 8) filler = eq8_filler;
  if (num == 9) filler = eq9_filler;
  if (num == 10) filler = eq10_filler;
 
  int f = ((value + 127) * (filler.getLength()-1)) / 255;
  if (Value == 255) filler.gotoFrame(f);
  else filler.gotoFrame(f + 1);
}
