/*--------------------------------------------------------------------
 Main/Stick player group script.
 
 by Plague
--------------------------------------------------------------------*/

#include <lib/std.mi>
#include "appname.m"
#include "attribs.m"

Function String getMinus(int CurPos);
Function fillBar(int value);
Function setTempText(String txt);
Function emptyTempText();

Global Text Songticker, time;
Global Slider Volbar;
Global AnimatedLayer vol_filler;
Global Group pgroup, rightContent, display, optionsBtn, standardVis;
Global Boolean ScrollTicker, alwaysOnTop, enableTooltips, alternateFonts, dockWindows, MinusIsOn;
Global Boolean notifierAlways, notifierWindowshade, notifierMinimized, notifierNever, notifierDisableFullscreen;

Class Button HintObject;
Global HintObject Play, Stop, Previous, Next, Pause, Open, Ml, Pl, ControlMenu, Minimize, Winshade, Close, Shuffle, Repeat, XFade, Options;

Global GuiObject visoverlay, viscover;
Global vis visdef;

Global Popupmenu visMenu, optionsMenu, notifMenu;
Global Int choice, curMode;

Global Timer tmrWait;

System.onScriptUnloading() {
  delete visMenu;
  delete optionsMenu;
  delete notifMenu;
  tmrWait.stop();
  delete tmrWait;
}

System.onScriptLoaded() {
  initAttribs();

  pgroup = getScriptGroup();

  // Get songticker, Volbar & Seeker
  Songticker = pgroup.findObject("Songticker");
  if (songticker == null) messagebox("ooch!!", "ooch", 0, "");
  Volbar = pgroup.findObject("Volume");

  // Get Various buttons
  Play = pgroup.findObject("Play");
  Pause = pgroup.findObject("Pause");
  Stop = pgroup.findObject("Stop");
  Next = pgroup.findObject("Next");
  Previous = pgroup.findObject("Previous");
  Open = pgroup.findObject("Eject");
  Ml = pgroup.findObject("Ml");
  Pl = pgroup.findObject("Pl");
  ControlMenu = pgroup.findObject("ControlMenu");
  Minimize = pgroup.findObject("Minimize");
  Winshade = pgroup.findObject("Winshade");
  Close = pgroup.findObject("Close");
  Shuffle = pgroup.findObject("Shuffle");
  Repeat = pgroup.findObject("Repeat");
  XFade = pgroup.findObject("Crossfade");
  Options = pgroup.findObject("options");

  vol_filler = pgroup.findObject("Volume fill");

  rightContent = pgroup.findObject("right-content");
  display = pgroup.findObject("display");
  optionsBtn = pgroup.findObject("optionsBtn");
  standardVis = pgroup.findObject("Standard Vis");

  time = pgroup.findObject("timer");

  // Get vis, overlay & cover
  visdef = pgroup.findObject("vis");
  visoverlay = pgroup.findObject("vis.overlay");
  viscover = pgroup.findObject("vis.cover");

  curMode = stringToInteger(myattr_visMode.getData());
  if (curMode == 1) visoverlay.show();
  else visoverlay.hide();
  visdef.setMode(curMode);

  visMenu = New PopupMenu;
  visMenu.addCommand("No visualization",0,0,0);
  visMenu.addCommand("Spectrum analyzer",1,0,0);
  visMenu.addCommand("Oscilliscope",2,0,0);

  notifMenu = New PopupMenu;
  notifMenu.addCommand("Show Always",6,0,0);
  notifMenu.addCommand("Show With Stick And When Minimized",7,0,0);
  notifMenu.addCommand("Show Only When Minimized",8,0,0);
  notifMenu.addCommand("Never Show",9,0,0);
  notifMenu.addSeparator();
  notifMenu.addCommand("Disable In Fullscreen",10,0,0);

  optionsMenu = New PopupMenu;
  optionsMenu.addSubMenu(notifMenu, "Notifications");
  optionsMenu.addCommand("Scroll Songticker",1,0,0);
  optionsMenu.addCommand("Always On Top",2,0,0);
  optionsMenu.addCommand("Enable Tooltips",3,0,0);
  optionsMenu.addCommand("Alternate Fonts",4,0,0);
  optionsMenu.addCommand("Dock Windows",5,0,0);

  tmrWait = new Timer;
  tmrWait.setDelay(20);

  MinusIsOn = getPrivateInt("D-Reliction", "Minus", 0);

  if (System.getStatus() == 1) tmrWait.start();

  fillBar(Volbar.getPosition());

  ScrollTicker = stringToInteger(myattr_scrollSongticker.getData());
  if (!ScrollTicker) Songticker.setXmlParam("ticker", "0");
}

myattr_scrollSongticker.onDataChanged() {
  ScrollTicker = stringToInteger(myattr_scrollSongticker.getData());
  if (ScrollTicker) Songticker.setXmlParam("ticker", "1");
  else Songticker.setXmlParam("ticker", "0");
}

#ifdef WASABI_PLAYER
Songticker.onLeftButtonDblClk(int x, int y) {
  if (isNamedWindowVisible("guid:{6A17D510-7833-4CEC-A420-F08F4B280782}")) {
    hideNamedWindow("guid:{6A17D510-7833-4CEC-A420-F08F4B280782}");
    return;
  }
  showWindow("guid:{6A17D510-7833-4CEC-A420-F08F4B280782}", "", false);
}
#endif

System.onPlay() {
  tmrWait.start();
}

System.onStop() {
  tmrWait.stop();
  time.setText("");
}

tmrWait.onTimer() {
  MinusIsOn = getPrivateInt("D-Reliction", "Minus", 0);
  if (MinusIsOn) time.setText(getMinus(getPlayItemLength()-getPosition()));
  else time.setText(getMinus(getPosition()));
}

time.onLeftButtonDown(int x, int y) {
  MinusIsOn = !MinusIsOn;
  setPrivateInt("D-Reliction","Minus", MinusIsOn);
}

String getMinus(int CurPos) {
  String SpecTmr = integerToTime(CurPos);

  if (MinusIsOn) SpecTmr = "-" + SpecTmr;
  else SpecTmr = " " + SpecTmr;

  return SpecTmr;
}

pgroup.onResize(int x, int y, int w, int h) {
  if (w >= 300) rightContent.show();
  else rightContent.hide();
}

rightContent.onResize(int x, int y, int w, int h) {
  if (w >= 132) {
    display.setXmlParam("w", "-35");
    optionsBtn.show();
  } else {
    display.setXmlParam("w", "-4");
    optionsBtn.hide();
  }
}

display.onResize(int x, int y, int w, int h) {
  if (w >= 100) {
    if (w >= 152) {
      time.setXmlParam("x", "-101");
      Songticker.setXmlParam("w", "-109");
      standardVis.show();
    } else {
      standardVis.hide();
      time.setXmlParam("x", "-46");
      Songticker.setXmlParam("w", "-54");
    }
    time.show();
  } else {
    Songticker.setXmlParam("w", "-10");
    time.hide();
    standardVis.hide();
  }
}

Volbar.onPostedPosition(int p) {
  fillBar(p);
}

Volbar.onSetPosition(int p) {
  Float f;
  f = p;
  f = f / 255 * 100;
  setTempText("Volume: " + System.integerToString(f) + "%");
  fillBar(p);
}

Volbar.onSetFinalPosition(int p) {
  emptyTempText();
}

HintObject.onLeftButtonDown(int x, int y) {
  if (HintObject == Play) setTempText("Play");
  else if (HintObject == Stop) setTempText("Stop");
  else if (HintObject == Pause) setTempText("Pause");
  else if (HintObject == Next) setTempText("Next");
  else if (HintObject == Previous) setTempText("Previous");
  else if (HintObject == Open) setTempText("Open");
  else if (HintObject == ML) setTempText("Media Library");
  else if (HintObject == Pl) setTempText("Playlist Editor");
  else if (HintObject == Shuffle) setTempText("Shuffle");
  else if (HintObject == Repeat) setTempText("Repeat");
  else if (HintObject == XFade) setTempText("Crossfade");
  else if (HintObject == ControlMenu) setTempText("Control Menu");
  else if (HintObject == Minimize) setTempText("Minimize");
  else if (HintObject == Winshade) setTempText("Switch Window Mode");
  else if (HintObject == Close) setTempText("Exit");
  else if (HintObject == Options) setTempText("Options");
}

HintObject.onLeftButtonUp(int x, int y) {
  emptyTempText();
}

HintObject.onLeftClick() {
  emptyTempText();

  if (HintObject == Options) {
    ScrollTicker = stringToInteger(myattr_scrollSongticker.getData());
    alwaysOnTop = StringToInteger(myattr_alwaysOnTop.getData());
    enableTooltips = StringToInteger(myattr_enableTooltips.getData());
    alternateFonts = StringToInteger(myattr_alternateFonts.getData());
    dockWindows = StringToInteger(myattr_dockWindows.getData());

    notifierAlways = StringToInteger(myattr_notifierAlways.getData());
    notifierWindowshade = StringToInteger(myattr_notifierWindowshade.getData());
    notifierMinimized = StringToInteger(myattr_notifierMinimized.getData());
    notifierNever = StringToInteger(myattr_notifierNever.getData());
    notifierDisableFullscreen = StringToInteger(myattr_notifierDisableFullscreen.getData());

    notifMenu.checkCommand(6, notifierAlways);
    notifMenu.checkCommand(7, notifierWindowshade);
    notifMenu.checkCommand(8, notifierMinimized);
    notifMenu.checkCommand(9, notifierNever);
    notifMenu.checkCommand(10, notifierDisableFullscreen);

    optionsMenu.checkCommand(1, ScrollTicker);
    optionsMenu.checkCommand(2, alwaysOnTop);
    optionsMenu.checkCommand(3, enableTooltips);
    optionsMenu.checkCommand(4, alternateFonts);
    optionsMenu.checkCommand(5, dockWindows);
    choice = optionsMenu.popAtMouse();

    if (choice == 1) myattr_scrollSongticker.setData(integerToString(!ScrollTicker));
    else if (choice == 2) myattr_alwaysOnTop.setData(IntegerToString(!alwaysOnTop));
    else if (choice == 3) myattr_enableTooltips.setData(IntegerToString(!enableTooltips));
    else if (choice == 4) myattr_alternateFonts.setData(IntegerToString(!alternateFonts));
    else if (choice == 5) myattr_dockWindows.setData(IntegerToString(!dockWindows));
    else if (choice == 6) myattr_notifierAlways.setData("1");
    else if (choice == 7) myattr_notifierWindowshade.setData("1");
    else if (choice == 8) myattr_notifierMinimized.setData("1");
    else if (choice == 9) myattr_notifierNever.setData("1");
    else if (choice == 10) myattr_notifierDisableFullscreen.setData(IntegerToString(!notifierDisableFullscreen));
    Complete;
  }
}

myattr_visMode.onDataChanged() {
  curMode = stringToInteger(myattr_visMode.getData());
  if (curMode == 1) visoverlay.show();
  else visoverlay.hide();
  visdef.setMode(curMode);
}

viscover.OnLeftButtonDown(int x, int y) {
  curMode = visdef.getMode();
  if (curMode >= 0 && curMode < 2) curMode++;
  else if (curMode == 2) curMode = 0;

  if (curMode == 1) visoverlay.show();
  else visoverlay.hide();
  visdef.setMode(curMode);
  myattr_visMode.setData(integerToString(curMode));
}

viscover.OnRightButtonUp(int x, int y) {
  curMode = visdef.getMode();
  for (int i = 0; i <= 2; i++) visMenu.checkCommand(i, curMode == i);
  choice = visMenu.popAtMouse();
  if (choice >= 0 && choice <= 2) curMode = choice;
  if (curMode == 1) visoverlay.show();
  else visoverlay.hide();
  visdef.setMode(curMode);
  myattr_visMode.setData(integerToString(curMode));
  Complete;
}

fillBar(int value) {
  int f = (value * (vol_filler.getLength()-1)) / 255;
  if (Value == 255) vol_filler.gotoFrame(f);
  else if (value == 0) vol_filler.gotoFrame(0);
  else vol_filler.gotoFrame(f + 1);
}

setTempText(String txt) {
  Songticker.setAlternateText(txt);
}

emptyTempText() {
  Songticker.setAlternateText("");
}
