/*--------------------------------------------------------------------
 Main/Normal player group script.
 
 by Plague
--------------------------------------------------------------------*/

#include <lib/std.mi>
#include "appname.m"
#include "attribs.m"

Function String getBitrate(String info);
Function String getSamplerate(String info);
Function Int getNumChannels(String info);
Function fillBar(int value);
Function setEqTempText(String band, int value);
Function setTempText(String txt);
Function emptyTempText();

Global Text Songticker, Bitrate, Samplerate, Infoline;
Global Slider Volbar, Panbar, Preamp;
Global AnimatedLayer vol_filler;
Global Int SavedVol, DrawerGroup, CfgPage;
Global Boolean ScrollTicker;

Class Slider EqBand;
Global EqBand eq1, eq2, eq3, eq4, eq5, eq6, eq7, eq8, eq9, eq10;
Global Button EqMax, EqReset, EqMin;

Class Button HintObject;
Global HintObject Play, Stop, Previous, Next, Pause, Open, Eq, Ml, Pl, Mute, MaxVol, ControlMenu, Minimize, Winshade, Close;
Global HintObject Drawer, Drawer2, Shuffle, Shuffle2, Repeat, Repeat2, XFade, XFade2, AOT, EqOn, EqAuto, EqPresets, Cfg, Colors;
Global HintObject Minitips, Minitips2, Nextcfgpage, Prevcfgpage;

Global Group Equalizer, Configuration, ColorThemes, Configpage1, Configpage2;
Global GuiObject mono, stereo;

System.onScriptUnloading() {
  setVolume(SavedVol);
  setPrivateInt("D-Reliction","DrawerGroup",DrawerGroup);
  setPrivateInt("D-Reliction","CfgPage",CfgPage);
}

System.onScriptLoaded() {
  initAttribs();

  Group pgroup = getScriptGroup();

  // Get songticker, Volbar & Seeker
  Songticker = pgroup.findObject("Songticker");
  if (songticker == null) messagebox("ooch!!", "ooch", 0, "");
  Volbar = pgroup.findObject("Volume");

  // Get Panbar
  Panbar = pgroup.findObject("balance");

  // Get EQ sliders & buttons
  Preamp = pgroup.findObject("preamp");
  eq1 = pgroup.findObject("eq1");
  eq2 = pgroup.findObject("eq2");
  eq3 = pgroup.findObject("eq3");
  eq4 = pgroup.findObject("eq4");
  eq5 = pgroup.findObject("eq5");
  eq6 = pgroup.findObject("eq6");
  eq7 = pgroup.findObject("eq7");
  eq8 = pgroup.findObject("eq8");
  eq9 = pgroup.findObject("eq9");
  eq10 = pgroup.findObject("eq10");
  EqMax = pgroup.findObject("eqMax");
  EqReset = pgroup.findObject("eqReset");
  EqMin = pgroup.findObject("eqMin");

  // Get Various buttons
  Play = pgroup.findObject("Play");
  Pause = pgroup.findObject("Pause");
  Stop = pgroup.findObject("Stop");
  Next = pgroup.findObject("Next");
  Previous = pgroup.findObject("Previous");
  Open = pgroup.findObject("Eject");
  Ml = pgroup.findObject("Ml");
  Pl = pgroup.findObject("Pl");
  Drawer = pgroup.findObject("drawer");
  Drawer2 = pgroup.findObject("Toggle Drawer");
  ControlMenu = pgroup.findObject("ControlMenu");
  Minimize = pgroup.findObject("Minimize");
  Winshade = pgroup.findObject("Winshade");
  Close = pgroup.findObject("Close");
  Mute = pgroup.findObject("Mute");
  MaxVol = pgroup.findObject("MaxVol");
  Shuffle = pgroup.findObject("Shuffle");
  Shuffle2 = pgroup.findObject("Shuffle status");
  Repeat = pgroup.findObject("Repeat");
  Repeat2 = pgroup.findObject("Repeat status");
  XFade = pgroup.findObject("Crossfade");
  XFade2 = pgroup.findObject("XFade status");
  AOT = pgroup.findObject("AOT");
  EqOn = pgroup.findObject("toggle");
  EqAuto = pgroup.findObject("auto");
  EqPresets = pgroup.findObject("presets");
  Eq = pgroup.findObject("Toggle Equalizer");
  Cfg = pgroup.findObject("Toggle Config");
  Colors = pgroup.findObject("Toggle Colors");
  Minitips = pgroup.findObject("Minitips");
  Minitips2 = pgroup.findObject("Minitips2");
  Nextcfgpage = pgroup.findObject("Nextcfgpage");
  Prevcfgpage = pgroup.findObject("Prevcfgpage");

  // Get some groups
  Equalizer = pgroup.findObject("Equalizer");
  Configuration = pgroup.findObject("Configuration");
  ColorThemes = pgroup.findObject("Color Themes");
  Configpage1 = pgroup.findObject("Configpage1");
  Configpage2 = pgroup.findObject("Configpage2");

  // Get Bitrate/Samplerate
  Bitrate = pgroup.findObject("Bitrate");
  Samplerate = pgroup.findObject("Samplerate");

  // Get mono/stereo layers
  mono = pgroup.findObject("mono");
  stereo = pgroup.findObject("stereo");

  vol_filler = pgroup.findObject("Volume fill");

  SavedVol = getVolume();

  fillBar(Volbar.getPosition());

  CfgPage = getPrivateInt("D-Reliction","CfgPage",1);
  DrawerGroup = getPrivateInt("D-Reliction","DrawerGroup",1);
  if (DrawerGroup == 1) Eq.leftClick();
  if (DrawerGroup == 2) Cfg.leftClick();
  if (DrawerGroup == 3) Colors.leftClick();

  ScrollTicker = stringToInteger(myattr_scrollSongticker.getData());
  if (!ScrollTicker) Songticker.setXmlParam("ticker", "0");

#ifdef WASABI_PLAYER
  Infoline = pgroup.findObject("Infoline");
/*  Infoline.setText(".");
  Infoline.setText("");
*/
  if (getStatus() != 0) {
    Bitrate.setText(getBitrate(Infoline.getText()));
    Samplerate.setText(getSamplerate(Infoline.getText()));
    if (getNumChannels(Infoline.getText()) == 1) mono.setAlpha(255);
    else if (getNumChannels(Infoline.getText()) == 2) stereo.setAlpha(255);
  }
#endif
#ifdef WINAMP5
  if (getStatus() != 0) {
    Bitrate.setText(getBitrate(getSongInfoText()));
    Samplerate.setText(getSamplerate(getSongInfoText()));
    if (getNumChannels(getSongInfoText()) == 1) mono.setAlpha(255);
    else if (getNumChannels(getSongInfoText()) == 2) stereo.setAlpha(255);
  }
#endif
}

myattr_scrollSongticker.onDataChanged() {
  ScrollTicker = stringToInteger(myattr_scrollSongticker.getData());
  if (ScrollTicker) Songticker.setXmlParam("ticker", "1");
  else Songticker.setXmlParam("ticker", "0");
}

#ifdef WASABI_PLAYER
Songticker.onLeftButtonDblClk(int x, int y) {
  if (isNamedWindowVisible("guid:{6A17D510-7833-4CEC-A420-F08F4B280782}")) {
    hideNamedWindow("guid:{6A17D510-7833-4CEC-A420-F08F4B280782}");
    return;
  }
  showWindow("guid:{6A17D510-7833-4CEC-A420-F08F4B280782}", "", false);
}
#endif

Volbar.onPostedPosition(int p) {
  fillBar(p);
  if (Mute.getActivated()) {
    if (getVolume() > 0) {
      Mute.setActivated(0);
      SavedVol = getVolume();
    }
  } else if (MaxVol.getActivated()) {
    if (getVolume() < 255) {
      MaxVol.setActivated(0);
      SavedVol = getVolume();
    }
  } else
    SavedVol = getVolume();
}

Volbar.onSetPosition(int p) {
  Float f;
  f = p;
  f = f / 255 * 100;
  setTempText("Volume: " + System.integerToString(f) + "%");
  fillBar(p);
  if (Mute.getActivated()) {
    if (getVolume() > 0) {
      Mute.setActivated(0);
      SavedVol = getVolume();
    }
  } else if (MaxVol.getActivated()) {
    if (getVolume() < 255) {
      MaxVol.setActivated(0);
      SavedVol = getVolume();
    }
  } else
    SavedVol = getVolume();
}

Volbar.onSetFinalPosition(int p) {
  emptyTempText();
}

HintObject.onLeftButtonDown(int x, int y) {
  if (HintObject == Play) setTempText("Play");
  else if (HintObject == Stop) setTempText("Stop");
  else if (HintObject == Pause) setTempText("Pause");
  else if (HintObject == Next) setTempText("Next");
  else if (HintObject == Previous) setTempText("Previous");
  else if (HintObject == Open) setTempText("Open");
  else if (HintObject == Eq) setTempText("Equalizer");
  else if (HintObject == ML) setTempText("Media Library");
  else if (HintObject == Pl) setTempText("Playlist Editor");
  else if (HintObject == Mute) setTempText("Mute");
  else if (HintObject == MaxVol) setTempText("Max Volume");
  else if (HintObject == Shuffle) setTempText("Shuffle");
  else if (HintObject == Shuffle2) setTempText("Shuffle");
  else if (HintObject == Repeat) setTempText("Repeat");
  else if (HintObject == Repeat2) setTempText("Repeat");
  else if (HintObject == XFade) setTempText("Crossfade");
  else if (HintObject == XFade2) setTempText("Crossfade");
  else if (HintObject == AOT) setTempText("Always On Top");
  else if (HintObject == ControlMenu) setTempText("Control Menu");
  else if (HintObject == Minimize) setTempText("Minimize");
  else if (HintObject == Winshade) setTempText("Switch Window Mode");
  else if (HintObject == Close) setTempText("Exit");
  else if (HintObject == EqOn) setTempText("EQ Processing");
  else if (HintObject == EqAuto) setTempText("EQ Automatic Processing");
  else if (HintObject == EqPresets) setTempText("Presets Menu");
  else if (HintObject == Cfg) setTempText("Skin Configuration");
  else if (HintObject == Colors) setTempText("Color Themes");
  else if (HintObject == Drawer) setTempText("Drawer");
  else if (HintObject == Drawer2) setTempText("Drawer");
  else if (HintObject == Minitips) setTempText("Skin Tips");
  else if (HintObject == Minitips2) setTempText("Skin Tips");
  else if (HintObject == Nextcfgpage) setTempText("Next Page");
  else if (HintObject == Prevcfgpage) setTempText("Previous Page");
}

HintObject.onLeftButtonUp(int x, int y) {
  emptyTempText();
}

HintObject.onLeftClick() {
  if (HintObject == Mute) {
	if (Mute.getActivated()) {
      setVolume(SavedVol);
      Mute.setActivated(0);
    } else {
      if (!MaxVol.getActivated()) SavedVol = getVolume();
      setVolume(0);
      Mute.setActivated(1);
      MaxVol.setActivated(0);
    }
  } else if (HintObject == MaxVol) {
	if (MaxVol.getActivated()) {
      setVolume(SavedVol);
      MaxVol.setActivated(0);
    } else {
      if (!Mute.getActivated()) SavedVol = getVolume();
      setVolume(255);
      MaxVol.setActivated(1);
      Mute.setActivated(0);
    }
  } else if (HintObject == Eq) {
    DrawerGroup = 1;
    Equalizer.show();
    Configuration.hide();
    ColorThemes.hide();
    Eq.setActivated(1);
    Cfg.setActivated(0);
    Colors.setActivated(0);
  } else if (HintObject == Cfg) {
    DrawerGroup = 2;
    Equalizer.hide();
    if (CfgPage == 1) {
      Configpage1.show();
      Configpage2.hide();
    } else if (CfgPage == 2) {
      Configpage2.show();
      Configpage1.hide();
    }
    Configuration.show();
    ColorThemes.hide();
    Eq.setActivated(0);
    Cfg.setActivated(1);
    Colors.setActivated(0);
  } else if (HintObject == Colors) {
    DrawerGroup = 3;
    Equalizer.hide();
    Configuration.hide();
    ColorThemes.show();
    Eq.setActivated(0);
    Cfg.setActivated(0);
    Colors.setActivated(1);
  } else if (HintObject == Nextcfgpage) {
    CfgPage = 2;
    Configpage2.show();
    Configpage1.hide();
  } else if (HintObject == Prevcfgpage) {
    CfgPage = 1;
    Configpage1.show();
    Configpage2.hide();
  }
}

EqMax.onLeftButtonDown(int x, int y) {
  for(int i=0; i<10; i++) setEqBand(i, 127);
}

EqReset.onLeftButtonDown(int x, int y) {
  for(int i=0; i<10; i++) setEqBand(i, 0);
}

EqMin.onLeftButtonDown(int x, int y) {
  for(int i=0; i<10; i++) setEqBand(i, -127);
}

setEqTempText(String band, int value) {
  Float f;
  f = value;
  f = f / 6.35;
  if (f >= 0) setTempText("EQ: " + band + "Hz: +" + floattostring(f, 1) + " DB");
  else setTempText("EQ: " + band + "Hz: " + floattostring(f, 1) + " DB");
}

EqBand.onSetPosition(int p) {
  if (EqBand == eq1) setEqTempText("60", p);
  else if (EqBand == eq2) setEqTempText("170", p);
  else if (EqBand == eq3) setEqTempText("310", p);
  else if (EqBand == eq4) setEqTempText("600", p);
  else if (EqBand == eq5) setEqTempText("1k", p);
  else if (EqBand == eq6) setEqTempText("3k", p);
  else if (EqBand == eq7) setEqTempText("6k", p);
  else if (EqBand == eq8) setEqTempText("12k", p);
  else if (EqBand == eq9) setEqTempText("14k", p);
  else if (EqBand == eq10) setEqTempText("16k", p);
}

EqBand.onSetFinalPosition(int p) {
  emptyTempText();
}

Preamp.onSetPosition(int p) {
  Float f;
  f = p;
  f = f / 6.35;
  if (f >= 0) setTempText("EQ: Preamp: +" + floattostring(f, 1) + " DB");
  else setTempText("EQ: Preamp: " + floattostring(f, 1) + " DB");
}

Preamp.onSetFinalPosition(int p) {
  emptyTempText();
}

Panbar.onSetPosition(int p) {
  Float f;
  if (p < 127) {
    f = p;
    f = (127 - f) / 127 * 100;
    setTempText("Balance: " + integerToString(f) + "% Left");
  } else if (p > 128) {
    f = p;
    f = (f - 127) / 127 * 100;
    setTempText("Balance: " + integerToString(f) + "% Right");
  } else
    setTempText("Balance: Center");
}

Panbar.onSetFinalPosition(int p) {
  emptyTempText();
}

System.onStop() {
  Bitrate.setText("");
  Samplerate.setText("");
  mono.setAlpha(0);
  stereo.setAlpha(0);
}

#ifdef WASABI_PLAYER
Infoline.onTextChanged(string info) {
  Bitrate.setText(getBitrate(info));
  Samplerate.setText(getSamplerate(info));

  if (getNumChannels(info) == 1) {
    stereo.setAlpha(0);
    mono.setAlpha(255);
  } else if (getNumChannels(info) == 2) {
    stereo.setAlpha(255);
    mono.setAlpha(0);
  } else {
    stereo.setAlpha(0);
    mono.setAlpha(0);
  }
}
#endif

#ifdef WINAMP5
System.onInfoChange(String info) {
  Bitrate.setText(getBitrate(info));
  Samplerate.setText(getSamplerate(info));

  if (getNumChannels(info) == 1) {
    stereo.setAlpha(0);
    mono.setAlpha(255);
  } else if (getNumChannels(info) == 2) {
    stereo.setAlpha(255);
    mono.setAlpha(0);
  } else {
    stereo.setAlpha(0);
    mono.setAlpha(0);
  }
}
#endif

string getBitrate(String info) {
int searchResult;
String rtn;
  for (int i = 0; i < 5; i++) {
    rtn = getToken(strlower(info), " ", i);
    searchResult = strsearch(rtn, "kbps");
    if (searchResult > 0) {
      rtn = Strleft(rtn, searchResult);
      searchResult = strsearch(rtn, ".");
      if (searchResult > 0) rtn = Strleft(rtn, searchResult);
      if (strlen(rtn) == 1) rtn = "  " + rtn;
      else if (strlen(rtn) == 2) rtn = " " + rtn;
      return rtn;
    }
  }
  return "";
}

string getSamplerate(String info) {
int searchResult;
String rtn;
  for (int i = 0; i < 5; i++) {
    rtn = getToken(strlower(info), " ", i);
    searchResult = strsearch(rtn, "khz");
    if (searchResult > 0) {
      rtn = Strleft(rtn, searchResult);
      searchResult = strsearch(rtn, ".");
      if (searchResult > 0) rtn = Strleft(rtn, searchResult);
      if (strlen(rtn) == 1) rtn = " " + rtn;
      return rtn;
    }
  }
  return "";
}

int getNumChannels(String info) {
  if (StrSearch(strlower(info), "mono") != -1) return 1;
  if (StrSearch(strlower(info), "stereo") != -1) return 2;
  return -1;
}

fillBar(int value) {
  int f = (value * (vol_filler.getLength()-1)) / 255;
  if (Value == 255) vol_filler.gotoFrame(f);
  else if (value == 0) vol_filler.gotoFrame(0);
  else vol_filler.gotoFrame(f + 1);
}

setTempText(String txt) {
  Songticker.setAlternateText(txt);
}

emptyTempText() {
  Songticker.setAlternateText("");
}
