/*-----------------------------------------------------------------------------
  notifiertimebyframe.m

  by Plague (Linus Brolin)
  based on seekbyframe.m, by FrisbeeMonkey
-----------------------------------------------------------------------------*/

#include <lib/std.mi>
#include "attribs.m"

Function setNotifierBarAnim(int posValue);
Function updateNotifierBar(int x, int y);

Global AnimatedLayer Notifierbar;
Global Map notifierMap;
Global Text SongTicker;
Global Boolean NotifierbarChanging;

System.onScriptLoaded() {
  initAttribs();

  group pgroup = getScriptGroup();
  Notifierbar = pgroup.findObject("NotifierTimeAnim");
  Songticker = pgroup.findObject("SongTicker");

  notifierMap = new Map;
  notifierMap.loadMap("player.map.notifiertime");

  int frame = stringToInteger(myattr_notifierHoldtime.getData());
  setNotifierBarAnim(frame);
}

System.onScriptUnloading() {
  delete notifierMap;
}

setNotifierBarAnim(int Value) {
  Value = Value / 1000;
  int f = (Value * (Notifierbar.getLength()-1)) / 21;
  if (Value > 0) Notifierbar.gotoFrame(f+1);
  if (Value == 21) Notifierbar.gotoFrame(f);
  if (Value == 0) Notifierbar.gotoFrame(0);
}

myattr_notifierHoldtime.onDataChanged() {
  int frame = stringToInteger(myattr_notifierHoldtime.getData());
  setNotifierBarAnim(frame);
}

Notifierbar.onLeftButtonDown(int x, int y) {
  NotifierbarChanging = 1;
  updateNotifierBar(x, y);
}

Notifierbar.onLeftButtonUp(int x, int y) {
  if (NotifierbarChanging) {
    NotifierbarChanging = 0;
    updateNotifierBar(x, y);
  }
  Songticker.setAlternateText("");
}

Notifierbar.onMouseMove(int x, int y) {
  if (NotifierbarChanging) {
    updateNotifierBar(x, y);
  }
}

updateNotifierBar(int x, int y) {
  int newValue = notifierMap.getValue(x - Notifierbar.getLeft() + 20, y - Notifierbar.getTop() + 20);
  if (notifierMap.inRegion(x - Notifierbar.getLeft() + 20, y - Notifierbar.getTop() + 20)) {
    int p = (newValue * 21) / 255;
    if (p == 1) Songticker.setAlternateText("Notifications Time: " + integerToString(p) + " second");
    else Songticker.setAlternateText("Notifications Time: " + integerToString(p) + " seconds");
    setNotifierBarAnim(p);
    myattr_notifierHoldtime.setData(IntegerToString(p * 1000));
  }
}
