/*

  Copyright (c) 2003-2004 Linus Brolin.

    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.


  Linus Brolin
  linus.b@home.se

*/

/*-----------------------------------------------------------------------------
  "RepeatMenu" script
  Adds a rightclick menu to the repeat button,
  which lets you choose the buttons repeat type.

  by Plague (Linus Brolin)
-----------------------------------------------------------------------------*/

#include <lib/std.mi>
#include "appname.m"
#include "attribs.m"

Global ToggleButton ToggleRepeat, RepeatStatus;

Global Popupmenu RepeatMenu;
Global Int choice;
Global String type;

System.onScriptUnloading() {
  delete RepeatMenu;
}

System.onScriptLoaded() {
  initAttribs();

  Group pgroup = getScriptGroup();
  ToggleRepeat = pgroup.findObject("Repeat");
  RepeatStatus = pgroup.findObject("Repeat status");

  RepeatMenu = New PopupMenu;
  RepeatMenu.addCommand("Repeat entire playlist",1,0,0);
  RepeatMenu.addCommand("Repeat single file",2,0,0);
#ifdef WASABI_PLAYER
  RepeatMenu.addCommand("Manual playlist advance only",3,0,0);
#endif

  type = myattr_repeatType.getData();
  ToggleRepeat.setXmlParam("cfgval", type);
  if (isObjectValid(RepeatStatus)) RepeatStatus.setXmlParam("cfgval", type);
}

myattr_repeatType.onDataChanged() {
  type = myattr_repeatType.getData();
  ToggleRepeat.setXmlParam("cfgval", type);
  if (isObjectValid(RepeatStatus)) RepeatStatus.setXmlParam("cfgval", type);
  attr_repeat.setData(type);
}

ToggleRepeat.onToggle(Boolean active) {
  type = myattr_repeatType.getData();
  ToggleRepeat.setXmlParam("cfgval", type);
}

ToggleRepeat.onRightButtonUp(int x, int y) {
//  type = ToggleRepeat.getXmlParam("cfgval");
  type = myattr_repeatType.getData();

  RepeatMenu.checkCommand(1, (type == "1"));
#ifdef WINAMP5
  RepeatMenu.checkCommand(2, (type == "-1"));
  choice = RepeatMenu.popAtMouse();
  if (choice == 1) myattr_repeatType.setData("1");
  if (choice == 2) myattr_repeatType.setData("-1");
#endif
#ifdef WASABI_PLAYER
  RepeatMenu.checkCommand(2, (type == "2"));
  RepeatMenu.checkCommand(3, (type == "3"));
  choice = RepeatMenu.popAtMouse();
  if (choice > 0 && choice <= 3) myattr_repeatType.setData(integerToString(choice));
#endif
  Complete;
}

RepeatStatus.onToggle(Boolean active) {
  type = myattr_repeatType.getData();
  RepeatStatus.setXmlParam("cfgval", type);
}

RepeatStatus.onRightButtonUp(int x, int y) {
//  type = RepeatStatus.getXmlParam("cfgval");
  type = myattr_repeatType.getData();

  RepeatMenu.checkCommand(1, (type == "1"));
#ifdef WINAMP5
  RepeatMenu.checkCommand(2, (type == "-1"));
  choice = RepeatMenu.popAtMouse();
  if (choice == 1) myattr_repeatType.setData("1");
  if (choice == 2) myattr_repeatType.setData("-1");
#endif
#ifdef WASABI_PLAYER
  RepeatMenu.checkCommand(2, (type == "2"));
  RepeatMenu.checkCommand(3, (type == "3"));
  choice = RepeatMenu.popAtMouse();
  if (choice > 0 && choice <= 3) myattr_repeatType.setData(integerToString(choice));
#endif
  Complete;
}
